package net.sergeych.parsec3

import net.sergeych.unikrypto.SymmetricKey

open class Parsec3SecureServerSession(
    val sessionKey: SymmetricKey? = null
) : WithAdapter()

///**
// * Parsec3 secure adapter.
// * @param transport a parsec3 transport to establish connection with, for example [Parsec3WSClient].
// * @param sessionSalt a secret random string (should not long enough) used to maintain permanent session on client side.
// *   if this string will be changed, all stored session will be forced to reconnect. Using a random string will
// *   cause each connection to dance with Diffie-Hellman after every restart.
// */
//fun Parsec3SecureServer<S : Parsec3SecureServerSession, H : CommandHost<S>>(transport: Parsec3Transport<WithAdapter>, sessionSalt: String = randomId(107)) {
//
//    private val sessionTokenKey = SymmetricKeys.create(
//        HashAlgorithm.SHA3_256.digest(sessionSalt),
//        BytesId(HashAlgorithm.SHA3_256.digest(sessionSalt + "_keyid"))
//    )
//}