package net.sergeych.parsec3

import kotlinx.serialization.Serializable

@Serializable
class RestoreSessionArgs(
    val sessionToken: ByteArray,
    val controlMessage: ByteArray
)

class SecureServerApi<S: WithAdapter>: CommandHost<S>() {

    val restoreSession by command<RestoreSessionArgs,ByteArray>()

    // reuqest session: server returns exchange, client provides one-time hello token, low security app token
    // or an empty array to identify self.
    val requestSession by command<ByteArray,ByteArray>()

    // create session: client sends its exchange, client returns encrypted
    val createSession by command<ByteArray,ByteArray>()


}