package parsec3

import net.sergeych.mptools.toDump
import net.sergeych.parsec3.KVStorage
import net.sergeych.parsec3.MemoryKVStorage
import net.sergeych.parsec3.stored
import kotlin.test.Test
import kotlin.test.assertEquals
import kotlin.test.assertNull

class TextSt(kvs: KVStorage) {
    var x: String? by kvs.stored(null)
}

@Suppress("UNUSED_VARIABLE")
internal class MemoryKVStorageTest {

    @Test
    fun testStorage() {
        val s = MemoryKVStorage()
        s.clear()
        println(s)
        println(s["foo"])
        s["foo"] = byteArrayOf(1,2,3)

        var bar: String? by s.stored(null)
        val bal: String? by s.stored(null)
        assertNull(bar)
        bar = "foo"
        println(s.get("bar")?.toDump())
        assertEquals("foo", bar)
        val foo: String by s.stored("", "bar")
        assertEquals("foo", foo)

        val t1 = TextSt(s)
        assertNull(t1.x)
        t1.x  = "bar"
        assertEquals("bar",t1.x)
        val t2 = TextSt(s)
        assertEquals("bar",t2.x)
//
//        var i: Int? by s(defaultValue = 17)
//        i = 19
//        var j: Int? by s("i")
//        assertEquals(19, j)

    }
}