import kotlin.test.fail

inline fun <reified T : Throwable> assertThrows(f: () -> Unit): T {
    try {
        f()
        fail("expected to throw ${T::class.simpleName} but threw nothing")
    } catch (e: Throwable) {
        if (e !is T) {
            println("unexpected error class: ${e::class.simpleName}")
            e.printStackTrace()
            fail("expected to throw ${T::class.simpleName} instead ${e::class.simpleName} was thrown: $e")
        }
        return e
    }
}

//fun assertThrowsCode(code: String, f: () -> Unit): Unit {
//    val err = assertThrows<ServiceError> {  f() }
//    if( err.code != code )
//        Assert.fail("expected error code '$code' got ${err.code}")
//}
